#!/bin/sh

repeat_char(){
	end="$1"
	for _ in $(seq 1 "$end") ; do
		printf '%s' "$2";
	done
}

header(){
	env printf "┌$(repeat_char 150 ─)┐\n"
	env printf '│ %-148s │\n' "$1"
	env printf "└$(repeat_char 150 '─')┘\n"
}

VENV_PATH='./.venv'

python3.12 -m venv --upgrade-deps "$VENV_PATH"
if [ -f "$VENV_PATH"/Scripts/activate ]; then . "$VENV_PATH"/Scripts/activate
elif [ -f "$VENV_PATH"/bin/activate ]; then . "$VENV_PATH"/bin/activate
else exit 1; fi
pip install --disable-pip-version pur
fd requirements.txt ~ | while read -r filename; do
	header "$(realpath "$filename" | sed "s,$HOME,~,")"
	pur -r "$filename"
done
deactivate
rm -rf "$VENV_PATH"
